/*
Copyright Renaud GICQUEL 2005-2009 
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import extThopt.*;
import java.util.*; 
import com.sun.java.swing.*;

public class Desorber extends ExtDivider implements Inversable
{
    protected static java.util.ResourceBundle resIntTh_fr = java.util.ResourceBundle.getBundle("IntTh",Locale.getDefault());  
    
	com.sun.java.swing.JLabel JLabel2 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Tgen_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel5 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Qgen_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel6 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Xsr_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel7 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField Xsp_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel10 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField compRef = new com.sun.java.swing.JTextField();
    
    double Tamont, Taval, Pamont, Paval,P;
    double epsiSol,Qabs,Qgen,Tabs,Tgen,Xsr,Xsp,msr,msp,mr,Prefr,Trefr,Hrefr,Hsp,Hsr,Tsr,Psr;
    String richSolutionProcess,refrigerantProcess,poorSolutionProcess;
    String richSolutionPoint,refrigerantPoint,poorSolutionPoint;
    Vector[]vTransfo,vPoints;
    CorpsExterne liBrH2O=new CorpsExterne(new LiBrH2OMixture());
    public Desorber (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,600,150);
		JLabel2.setText("desorber temperature (C)");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,22,164,20);
		JPanel1.add(Tgen_value);
		Tgen_value.setBounds(164,22,124,20);
		Tgen_value.setText("100");
		JLabel5.setText("desorber load");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,88,164,20);
		JPanel1.add(Qgen_value);
		Qgen_value.setBounds(164,88,124,20);
		Qgen_value.setText("200");
		JLabel6.setText("Rich solution fraction");
		JPanel1.add(JLabel6);
		JLabel6.setBounds(0,44,164,20);
		JPanel1.add(Xsr_value);
		Xsr_value.setBounds(164,44,124,20);
		Xsr_value.setText("0.6");
		JLabel7.setText("Poor solution fraction");
		JPanel1.add(JLabel7);
		JLabel7.setBounds(0,110,164,20);
		JPanel1.add(Xsp_value);
		Xsp_value.setBounds(164,110,124,20);
		Xsp_value.setText("0.5");
		JLabel10.setText("reference");
		JPanel1.add(JLabel10);
		JLabel10.setBounds(0,186,108,20);
		JPanel1.add(compRef);
		compRef.setBounds(108,186,192,20);
		type=getType();
		thermoCouplerTypes=new String[1];
		thermoCouplerTypes[0]="desorber";
		compRef.setText("desorber");
    }
    
    public String getType(){
        return "Desorber";
    }
    
	public String getClassDescription(){
	    return "LiBr absorption desorber\n\none thermocoupler\n\nauthor : R. Gicquel   january 2003\n\nRef : archive Desorber.zip";
	}
    
    
	public void calculateProcess(){
	
        Tgen=Util.lit_d(Tgen_value.getText())+273.15;
	    getDividerStructure();
        checkConsistency();
        System.out.println(" richSolutionProcess "+richSolutionProcess
            +" poorSolutionProcess "+poorSolutionProcess
            +"  refrigerantProcess "+refrigerantProcess+"  Prefr : "+Prefr);
	    
	    if(isBuilt){
            Xsp=Util.dicho_T (this,Prefr,Tgen, "P_LiBr",0.3, 0.55,0.00001);
            P=liBrH2O.getSatPressure(Tgen,Xsp);
            Hsp=liBrH2O.subst.calcH(Tgen,P,Xsp);//getH(Xsp,Tgen);
   //         Tsp=Tgen;
            System.out.println(" Xsr "+Xsr+" Xsp "+Xsp+"  P "+P+"   Prefr "+Prefr+"   Hsp "+Hsp+"   Tgen "+Tgen);
            mr=(Xsr-Xsp)/(1-Xsp)*msr;
            msp=msr*(1-Xsr)/(1-Xsp);
            System.out.println(" mr "+mr+"  msp "+msp+"   msr "+msr);
            Qgen=mr*Hrefr+msp*Hsp-msr*Hsr;
            System.out.println(" Qgen "+Qgen);
	        vTransfo= new Vector[nBranches+1];
	        vPoints= new Vector[nBranches+1];
            setupRichSolution(msr,Tsr,Psr,Xsr);
            setupPoorSolution(msp,Tgen,P,Xsp);
            setupRefrigerant(mr,Trefr,Prefr,1);
            updateDivider(vTransfo,vPoints,Tsr,Hsr);
            updateThermoCoupler("desorber", Tgen, Tgen, Qgen, msp);
            getUA("desorber");
	        Qgen_value.setText(Util.aff_d(Qgen,3));
	        Xsr_value.setText(Util.aff_d(Xsr,3));
	        Xsp_value.setText(Util.aff_d(Xsp,3));
	        updateStraightlyConnectedProcess(poorSolutionProcess, poorSolutionProcess, 
	            true,//boolean downstream, 
                true,//boolean inletPoint, 
                true,//boolean outletPoint, 
                false,//boolean updateT, 
                0,//double T,  
                false,//boolean updateP, 
                0,//double P, 
                true,//boolean updateX, 
                Xsp);
	        de.updateProcess(setEnergyTypes(richSolutionProcess,0,Qgen,0));
        }

	}
    private void setupRichSolution(double m, double T, double P, double X){
        vTransfo[0]=new Vector();
        vPoints[0]=new Vector();
        vTransfo[0].addElement(richSolutionProcess);
        vTransfo[0].addElement(new Double(m));
 
        vPoints[0].addElement(richSolutionPoint);
        vPoints[0].addElement(new Double(T));
        vPoints[0].addElement(new Double(P));
        vPoints[0].addElement(new Double(X));
    }
    private void setupPoorSolution(double m, double T, double P, double X){
        vTransfo[1]=new Vector();
        vPoints[1]=new Vector();
        vTransfo[1].addElement(poorSolutionProcess);
        vTransfo[1].addElement(new Double(m));
 
        vPoints[1].addElement(poorSolutionPoint);
        vPoints[1].addElement(new Double(T));
        vPoints[1].addElement(new Double(P));
        vPoints[1].addElement(new Double(X));
    }
    private void setupRefrigerant(double m, double T, double P, double X){
        vTransfo[2]=new Vector();
        vPoints[2]=new Vector();
        vTransfo[2].addElement(refrigerantProcess);
        vTransfo[2].addElement(new Double(m));
 
        vPoints[2].addElement(refrigerantPoint);
        vPoints[2].addElement(new Double(T));
        vPoints[2].addElement(new Double(P));
        vPoints[2].addElement(new Double(X));
    }
  
    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        poorSolutionProcess="";
        refrigerantProcess="";
     if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 2";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String amont=(String)vBranch[j].elementAt(1);//gets the upstream point name
	            getPointProperties(amont);//direct parsing of point property vector
                String nom=nomCorps;
                //Check the substance at inlet
                System.out.println(" ligne "+j+" nomCorps "+nomCorps);
	            if(nom.equals("LiBr-H2O mixture")){
	                poorSolutionProcess=nomBranche[j];
	                poorSolutionPoint=amont;
	            }
	            if(nom.equals(resIntTh_fr.getString("eau"))){
	                refrigerantProcess=nomBranche[j];
	                refrigerantPoint=amont;
	                Prefr=Ppoint;
	                Hrefr=Hpoint;
	                Trefr=Tpoint;
	            }
	        }
	        if((refrigerantProcess.equals(""))||(poorSolutionProcess.equals(""))){
	            String msg = "Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(de, msg);  
	            isBuilt=false;
	        }
        }
        richSolutionProcess=mainProcess;
	    args[0]="process";//type of the element (see method getProperties(String[] args))
	    args[1]=richSolutionProcess;//name of the process (see method getProperties(String[] args))
	    Vector vPropMain=proj.getProperties(args);
	    Double f=(Double)vPropMain.elementAt(3);
	    msr=f.doubleValue();
	    String aval=(String)vPropMain.elementAt(2);//gets the downstream point name
	    getPointProperties(aval);//direct parsing of point property vector
	    richSolutionPoint=aval;
	    Tsr=Tpoint;
	    Psr=Ppoint;
	    Hsr=Hpoint;
	    Xsr=Xpoint;
        String nom=nomCorps;
        
        //Check the substance at inlet
	    if(!(nom.equals("LiBr-H2O mixture"))){
	        String msg = "Error on main process substance,which is "+nomCorps+" instead of LiBr-H2O mixture";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
	    }
        
    }
  
  /*
	        Node the_node=getNode(nomType);
	        if(the_node!=null){
	            vProp.addElement(the_node.mainProcess.getName());//main process name
	            vProp.addElement(the_node.getClassType());//node type
	            vProp.addElement(the_node.getEffNode());//node efficiency
	            vProp.addElement(Util.aff_b(the_node.isoBaric));//is node isobaric?
	            vProp.addElement(new Integer(the_node.vBranch.size()));//number of branches
                for(int j=0;j<the_node.vBranch.size();j++){
                    Object[] branch=(Object[])the_node.vBranch.elementAt(j);
	                Transfo the_process=(Transfo)branch[0];
	                vProp.addElement(the_process.getName());//branch process name
	            }
	        }
  */
  
  

	public void readCompParameters(String ligne_data){
		Tgen=Util.lit_d(Util.extr_value(ligne_data, "Tgen_value"));
	    Tgen_value.setText(Util.aff_d(Tgen,3));
		Qgen=Util.lit_d(Util.extr_value(ligne_data, "Qgen_value"));
	    Qgen_value.setText(Util.aff_d(Qgen,3));
		Xsr=Util.lit_d(Util.extr_value(ligne_data, "Xsr_value"));
	    Xsr_value.setText(Util.aff_d(Xsr,3));
		Xsp=Util.lit_d(Util.extr_value(ligne_data, "Xsp_value"));
	    Xsp_value.setText(Util.aff_d(Xsp,3));
        String valeur=Util.extr_value(ligne_data, "compRef");
        if(valeur!=null)compRef.setText(valeur);
	}
	
    public String saveCompParameters(){
	    String h="Tgen_value="+Tgen_value.getText()+tab
	    +"Qgen_value="+Qgen_value.getText()+tab
	    +"Xsr_value="+Xsr_value.getText()+tab
	    +"Xsp_value="+Xsp_value.getText()+tab
	    +"compRef="+compRef.getText()+tab
	    ;
        return h;
    }
    public double f_dicho(double X, double T,String fonc){
        
        if (fonc.equals("P_LiBr"))return liBrH2O.getSatPressure(T,X);//liBrH2O.getP(X,T);
            

        if (fonc.equals("H_LiBr"))return liBrH2O.subst.calcH(T,P,X);//getH(X,T);
        
        return 0;
        
    }
 


}